%% This script will generate the distances from one node to another 
% with the hevasine method
tic
clc; clear all;
%load vesseldata
vesseldata = xlsread('shipparametrics.xlsx','Ark1','C4:J10');

%% Gereate number of nodes in the field
numnodes = 50; %

Lon = (-10:50/numnodes:40);
Lat = (52:28/numnodes:80);

coordinates = zeros(length(Lat),2);
coordinates(:,1) = Lat;
coordinates(:,2) = Lon;

kordinater = {Lat,Lon};
[a, b] = ndgrid(kordinater{:});
Coord = [a(:) b(:)];
[u,t] = size(Coord);


% This filters away coordinated that are in the water but are not of
% interest

for i = 1:u
    if landmask(Coord(i,1),Coord(i,2)) == 0
        Coord(i,:) = Coord(i,:);
    else
        Coord(i,:) = [NaN,NaN];
    end
end


for i = 1:u
    if Coord(i,2) >= 7 && Coord(i,1) <= 63
        Coord(i,:) = [NaN,NaN];
    elseif Coord(i,2) >= 13 && Coord(i,1) <= 67
        Coord(i,:) = [NaN,NaN];
    else 
        Coord(i,:) = Coord(i,:);
    end
end

Coordny = Coord;

%create zero matrix for the distance matrix
dist = zeros(length(Coordny));

%% Calculate distances based on coordinates
for i = 1:length(Coordny(:,1)) %i = lat
    for j = 1:length(Coordny(:,2)) %j = lon
        dist(i,j) = distance(Coordny(i,1),Coordny(i,2),Coordny(j,1),...
            Coordny(j,2),earthRadius('nm'))*1.1;
    end
end
%  
toc












