%% Plot results script.
%clear all 
%% Create fleets of vessels
% Eight vessel-types in each fleet

FULL_ENUM = 0;  %Fully enumerates design space
LATIN_HYP = 1;  %Latin hypercube sampling

MaxObj = 0;
cost = [27.2000	36.5000	34.3000	38.3800	36.9200	77.2200	55.2200	51.9300];

numfleettype = 12 ; %Number of fleets for each numfleet --> 5 * 6 = 30 
numfleet = 12; %Maximun number of vessels of each vesseltype

fleet = zeros(1,8);

for i = 1:numfleet
    if FULL_ENUM == 1
    Vs1 = 0:1:numfleettype;
    Vs2 = Vs1;
    Vs3 = Vs1;
    Vs4 = Vs1;
    Vs5 = Vs1;
    Vs6 = Vs1;
    Vs7 = Vs1;
    Vs8 = Vs1;
    Fleet_Comb = combvec(Vs1,Vs2,Vs3,Vs4,Vs5,Vs5,Vs6,Vs7);
    elseif LATIN_HYP == 1
    Fleet_Comb = round(i*lhsdesign(numfleettype,8,'smooth','off'));
    end  
   
    r_fleet = length(fleet(:,1));
    
    for j = 1:length(Fleet_Comb(:,1))
    fleet(r_fleet + j,:) = Fleet_Comb(j,:);
    end
end

fleet(1,:) = [];

%% Fleets being run through Xpress

for i = 1:length(fleet(:,1))
Vesselfleet = fleet(i,:);

fid = fopen('fleet1.txt','wt');
    fprintf(fid,'P: [ \n');
    for j = 1:length(Vesselfleet)
            fprintf(fid,'(');
    fprintf(fid,'%1.0f',j);
    fprintf(fid,')');
    fprintf(fid,'%2.0f %2.0f ',Vesselfleet(j));
    fprintf(fid,'\n');
    end
    fprintf(fid,']\n');
    
    % Initialize for Xpress Solver. 
DEPLOY = 0; %zeros(I,V);
COVERI = 0; %zeros(I,M);
BINARY = 0; %zeros(I,M);
MAXTIME = -20;  %Set maximum search time per instance.

[retcode, exitcode] = moselexec('maxcoveragesimple_Case3.mos')

if objval == 0 
    i = i+1; 
else
    FinalDeploy(i,:) = sum(DEPLOY);
    FinalObVal(i,1) = objval ;
    OptGap(i,1) = GAP;
    if objval >= MaxObj
        MaxObj = objval;
        finDeploy = DEPLOY; 
    end
end

%% Determine coverage 
covernodes = zeros(length(Coord),1);

for x = 1:length(Coord) 
    for y = 1:numMissions
        for z = 1:numVessels
            if COVERI(x,y,z) >= 1
                covernodes(x) = 1;
            end
        end
    end
end
co = Coord(:,1);
aktuellenoder = isfinite(Coord(:,1));

cn = sum(covernodes);
an = sum(aktuellenoder); 
snitt = cn/an;

nodecoverage(i) = snitt;
              

end

%% Locate optimality cap

for i = 1:length(OptGap)
Optimality_gap(i) = abs(FinalObVal(i)-OptGap(i))/FinalObVal(i);
end




    