%% Create Mosel text file 
%% MoselfileGen nedd to be runned before running this 
fid = fopen('DataInput_NY_case2.txt','wt');

%Sets: 
fprintf(fid,'!Sets \n');
fprintf(fid,'nNODES: ');
    fprintf(fid,'%1.0f \n',numNodes);
fprintf(fid,'nVESSELS: ');
    fprintf(fid,'%1.0f \n',numVessels);
fprintf(fid,'nMISSIONS: ');
    fprintf(fid,'%1.0f \n',numMissions);
fprintf(fid,'nK_vessels: ');
    fprintf(fid,'%1.0f \n',20);%numVessels
    fprintf(fid,'\n');
      
%Subsets: 
M = length(MP);

%% subset N_imv range dependant --> Case 2
% 
fprintf(fid,'!Subsets \n');
%Writes the NI(i,v,m): such that j will become a node in the subset if
%the distance between node j and i is less than the max resonse distance
%for vessel v, and that vessel v can perform mission m.
fprintf(fid,'N: [ \n');
for i = 1:length(Coord)
    for v = 1:length(VS)
        for m = 1:numMissions 
            nodesI = [];
             for j = 1:length(Coord)
                if S.dist(i,j)<= VR(v) && VR(v) >= 0 &&...
                        A(v,Missiontype(m)) == 1
                    nodesI = [nodesI, j];
                end
             end         
            fprintf(fid,'(');
            fprintf(fid,'%1.0f %2.0f %2.0f',i,v,m);
            fprintf(fid,') [');
            fprintf(fid,'%2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f ', nodesI);
            fprintf(fid,'] \n');
        end
    end
end
fprintf(fid,'] \n');

%% Subset where N_imv = (j|(d_ij/VS) <= TM) --> Case #

% fprintf(fid,'!Subsets \n');
% %Writes the NI(i,v,m): such that j will become a node in the subset if
% %the distance between node j and i is less than the max resonse distance
% %for vessel v, and that vessel v can perform mission m.
% fprintf(fid,'N: [ \n');
% for i = 1:length(Coord)
%     for v = 1:length(VS)
%         for m = 1:numMissions 
%             nodesI = [];
%              for j = 1:length(Coord)
%                 if S.dist(i,j)/VS(v) <= RT(m) && A(v,Missiontype(m)) == 1
%                     nodesI = [nodesI, j];
%                 end
%              end         
%             fprintf(fid,'(');
%             fprintf(fid,'%1.0f %2.0f %2.0f',i,v,m);
%             fprintf(fid,') [');
%             fprintf(fid,'%2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f %2.0f ', nodesI);
%             fprintf(fid,'] \n');
%         end
%     end
% end
% fprintf(fid,'] \n');

%Generates the subset V of vessels v 
fprintf(fid,'VI: [ \n');
for i = 1:length(Coord)
    vessels = [];
    for v = 1:length(VS)
        vessels = [vessels, v];
    end
    fprintf(fid,'(');
    fprintf(fid,'%1.0f',i);
    fprintf(fid,') [');
    fprintf(fid,'%2.0f %2.0f ',vessels);
    fprintf(fid,'] \n');
end
fprintf(fid,'] \n');

%Parameters: 
fprintf(fid,'!Parameters \n');
%Writes the WCP(i,m,k): "Points rewarded for covering node i"
 
fprintf(fid,'W: [ \n');
for i = 1:length(Coord)
    for k = 1:20%numVessels
        for m = 1:numMissions
    fprintf(fid,'(');
    fprintf(fid,'%1.0f %2.0f %2.0f',i,m,k);
    fprintf(fid,') ');
        fprintf(fid,'%2.3f ',WP(i)/((2^k)/2));
        
        fprintf(fid,' \n');
        end
    end 
end
fprintf(fid,']\n');

%Number of demanded vessels at node i 
%VD = Vessel Demand
fprintf(fid,'VD: [ \n');
for i = 1:length(Coord)
    fprintf(fid,'(');
    fprintf(fid,'%1.0f',i);
    fprintf(fid,') ');
    if MP(i) == 1
    fprintf(fid,'%2.0f ',1);  
    fprintf(fid,'\n');
    else 
    fprintf(fid,'%2.0f ',0);
    fprintf(fid,'\n');
    end
    
end
fprintf(fid,']\n');
fclose(fid);


