%% This file generates a text file %1

%clc; clear all;
%% Create distance matrix
%S = load('distMatrix.mat');
%Coord = S.Coord;

S = load('DistanceMatrixNY3.mat');
Coord = S.Coordny;

%run Distancematrix.m
%load vesseldata
vesseldata = xlsread('shipparametrics.xlsx','Ark1','C4:J10');
%vessel Speed
VS = vesseldata(2,:); 
%vessel capabilities 
A = transpose(xlsread('shipparametrics.xlsx','Ark1','C13:J16'));
% Mission response time 
RT = xlsread('shipparametrics.xlsx','Ark1','C18:C21');

%% Generate mission Demand points  
% 1 = required poatrol node
% 2 = oil recovery operation
% 3 = Tugging operation
% 4 = Search and rescue 

MP = zeros(length(Coord),1);


MP(671) = 2;
MP(630) = 2; 
MP(1927) = 1;
MP(1419) = 1; 
MP(490) = 1;
MP(272) = 1;
MP(730) = 4;
MP(1000) = 3;

Missiontype = MP;
Missiontype( ~any(Missiontype,2), : ) = [];

%% Create response time vector

RT = zeros(1,length(Missiontype));
for i = 1:length(Missiontype)
    if Missiontype(i) == 1
        RT(i) = 24;
    elseif Missiontype(i) == 2
        RT(i) = 16;
    elseif Missiontype(i) == 3
        RT(i) = 24;
    elseif Missiontype(i) == 4
        RT(i) = 12;
    end
end

%% Generating weights on the nodes 
WP = ones(length(Coord),1); %weighted point matrix 

for i = 1:length(Coord)
    if MP(i) == 1 
        for j = 1:length(Coord)
            if S.dist(j,i) == 0 
                WP(j) = WP(j)+6; 
            elseif S.dist(j,i) <= 25 && S.dist(j,i) > 0
                WP(j) = WP(j) + 4;
            elseif S.dist(j,i) <= 100 && S.dist(j,i) > 25
                WP(j) = WP(j) + 3; 
            elseif S.dist(j,i) <= 250 && S.dist(j,i) > 100
                WP(j) = WP(j) + 1; 
            
            end
            
        end
    elseif MP(i) == 2
        for j = 1:length(Coord)
            if S.dist(j,i) == 0 
                WP(j) = WP(j)+5; 
            elseif S.dist(j,i) <= 25 && S.dist(j,i) > 0
                WP(j) = WP(j) + 3;
            elseif S.dist(j,i) <= 100 && S.dist(j,i) > 25
                WP(j) = WP(j) + 2; 
            elseif S.dist(j,i) <= 250 && S.dist(j,i) > 100
                WP(j) = WP(j) + 1; 
            
            end
        end
     elseif MP(i) == 3
         for j = 1:length(Coord)
            if S.dist(j,i) == 0 
                WP(j) = WP(j)+7; 
            elseif S.dist(j,i) <= 25 && S.dist(j,i) > 0
                WP(j) = WP(j) + 5;
            elseif S.dist(j,i) <= 100 && S.dist(j,i) > 25
                WP(j) = WP(j) + 2; 
            elseif S.dist(j,i) <= 250 && S.dist(j,i) > 100
                WP(j) = WP(j) + 1; 
            
            end
         end
      elseif MP(i) == 4
         for j = 1:length(Coord)
            if S.dist(j,i) == 0 
                WP(j) = WP(j)+7; 
            elseif S.dist(j,i) <= 25 && S.dist(j,i) > 0
                WP(j) = WP(j) + 5;
            elseif S.dist(j,i) <= 100 && S.dist(j,i) > 25
                WP(j) = WP(j) + 2; 
            elseif S.dist(j,i) <= 250 && S.dist(j,i) > 100
                WP(j) = WP(j) + 1; 
            
            end
         end
    end
end

                
%% Determining vessel range in nautical miles
%VR = [190 250 200 180 170 150 220 230]; 
VR = [50 40 70 90 60 60 45 50];

%% Inputdata to mosel file 
%number of vessels 
numVessels = length(VS); 
%number of nodes
numNodes = length(Coord);
%number of missions 
numMissions = 0; %pre-defining numMissions
for i = 1:length(MP)
    if MP(i) >= 1
        numMissions = numMissions + 1; 

    end 
end 
        


