%% Plot results 

load DistanceMatrixNY4.mat

%% Plot the weighted contours

clf('reset')
    
cost = [27.2000	36.5000	34.3000	38.3800	36.9200	77.2200	55.2200	51.9300];

%% Code finding deployd vessels for Case 1.

% Dep2 = [];
% for i = 1:length(finDeploy)
%     for j = 1:8
%     if finDeploy(i,j) >= 0.95 && finDeploy(i,j) <= 1.05
%        Dep2(i,:) = Coord(i,:);
%     
%     end
%     end
% end
% Dep2( ~any(Dep2,2), : ) = [];

%% Code finding deployd vessels for case 2 and 3


Dep2 = [];
for i = 1:length(finDeploy)
    for j = 1:8
    if finDeploy(i,j) >= 0.95 
       Dep2(i,:) = Coord(i,:);
    
    end
    end
end
Dep2( ~any(Dep2,2), : ) = [];

        

for i = 1:length(FinalDeploy(:,1))
    deploy(i,1) = sum(FinalDeploy(i,:));
    CostFleet(i,1) = cost*transpose(FinalDeploy(i,:));
end




%% plot on map

workingFolder = tempdir;
files = gunzip('gshhs_c.b.gz', workingFolder);
filename = files{1};
indexfile = gshhs(filename, 'createindex');

latlim = [52  80];
lonlim = [-10 40];
S = gshhs(filename, latlim, lonlim);

%This section makes sure that we wish to plot the coastline. 
levels = [S.Level];
unique(levels);
L1 = S(levels == 1);



figure(2)
axesm('mercator', 'MapLatLimit', latlim, 'MapLonLimit', lonlim)
%gridm; 
mlabel; 
plabel;
grid off 
geoshow([L1.Lat], [L1.Lon], 'Color', 'black')
geoshow('landareas.shp', 'FaceColor', [0.15 0.5 0.15]);

%% Display contours on the map
 kontur = transpose(vec2mat(WP,51)); 
 contourm(a,b,kontur)

%geoshow(Coord(:,1), Coord(:,2),'DisplayType','point', 'Marker','.','Color','red','MarkerSize',2)
%geoshow(Dep2(:,1), Dep2(:,2),'DisplayType','point', 'Marker','*','Color','blue','MarkerSize',2)
geoshow(Dep2(:,1), Dep2(:,2),'DisplayType','point','MarkerEdgeColor','red') %display deployment



%% display accident sights
% Isolate the accidents 
acc = [];
for i = 1:length(MP)
    if MP(i) >= 1
       acc(i,:) = Coord(i,:);
    
    end
end
acc( ~any(acc,2), : ) = [];

%% Plot missions on map

%geoshow(Coord(:,1),Coord(:,2),'DisplayType','point','Marker','.','MarkerEdgeColor','red') %Plot coordinates 
%geoshow(acc(:,1), acc(:,2),'DisplayType','point', 'MarkerEdgeColor','blue') % plot missions

tightmap

%% Utility plots and optimality gaps 

utilityvector = FinalObVal/MaxObj;

figure(1)
subplot(2,1,1)       % add first plot in 2 x 1 grid
plot(deploy,utilityvector,'o')
title('Number of vessels')
xlabel('Number of vessels')
ylabel('Utility')

subplot(2,1,2)       % add second plot in 2 x 1 grid
plot(CostFleet,utilityvector,'o')
title('Cost')
xlabel('Cost of fleet [mUSD]')
ylabel('Utility')

figure(3)
plot(deploy,utilityvector,'o')

figure(5)
plot(CostFleet,utilityvector,'o')
title('Fleet Coverage')
xlabel('Cost of fleet [mUSD]')
ylabel('Utility')

% figure(4)
% plot(deploy,Optimality_gap,'o')


% figure(6)
% plot(CostFleet,Optimality_gap,'o')





